unit HKMessageRec;

{
  HKMessageReceiver v1.0
   By Harry Kakoulidis 11/1999

  kcm@mailbox.gr
  http://kakoulidis.homepage.com

  This is Freeware. Please copy the file unchanged.
  If you find bugs, have options etc. Please send at my e-mail.

  The use of this component is at your own risk.
  I do not take any responsibility for any damages.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TOnReceiveMessage = Procedure(Msg : cardinal; WParam,LParam : Integer) of object;

  THKMessageReceiver = class(TComponent)
  private
    FHooked : boolean;
    FOnReceiveMessage :  TOnReceiveMessage;
    function AppWindowHook(var Message:TMessage) : boolean;
  public
    constructor Create(AOWner : TComponent); override;
    Destructor Destroy; override;
  published
    Property OnReceiveMessage : TOnReceiveMessage read FOnReceiveMessage write FOnReceiveMessage;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Haka', [THKMessageReceiver]);
end;

{ THKMessageReceiver }

function THKMessageReceiver.AppWindowHook(var Message: TMessage): boolean;
begin
 result:=true;
  with message do begin
    if (Msg>=WM_USER) and (assigned(FOnReceiveMessage)) then
    FOnReceiveMessage(msg,WParam,LParam);
    AppWindowHook:=false;
  end;
end;

constructor THKMessageReceiver.Create(AOWner: TComponent);
begin
 inherited create(AOwner);
 if ComponentState=[] then begin
  Application.HookMainWindow(AppWindowHook);
  FHooked:=true;
 end else FHooked:=false;
end;

destructor THKMessageReceiver.Destroy;
begin
 if FHooked then Application.UnhookMainWindow(AppWindowHook);
 Inherited Destroy;
end;

end.
